
/* zodiac - advanced dns spoofer
 *
 * graphical user interface configuration routines
 *
 * by scut / teso
 */

#include "common.h"
#include "gui-config.h"


/* cs_dupe
 *
 * duplicate the configuration set pointed to by `original'
 * return a new one
 */

configset *
cs_dupe (configset *original)
{
	configset	*new = xcalloc (1, sizeof (configset));

	/* copy all present data to the new configuration set
	 */

	if (original->nameserver != NULL)
		new->nameserver = xstrdup (original->nameserver);
	if (original->local_dns != NULL)
		new->local_dns = xstrdup (original->local_dns);
	if (original->local_domain != NULL)
		new->local_domain = xstrdup (original->local_domain);
	new->spoof_type = original->spoof_type;
	if (original->spoof_from != NULL)
		new->spoof_from = xstrdup (original->spoof_from);
	if (original->spoof_to != NULL)
		new->spoof_to = xstrdup (original->spoof_to);

	return (new);
}


configset *
cs_new (void)
{
	configset	*new;

	new = xcalloc (1, sizeof (configset));
	cs_init (new);

	return (new);
}


/* cs_init
 *
 * initialize a configuration set pointed to by `cs_set'
 */

void
cs_init (configset *cs_set)
{
	cs_set->nameserver = cs_set->local_dns = cs_set->local_domain =
		cs_set->spoof_name = cs_set->spoof_ip = NULL;
	cs_set->spoof_type = 0;

	return;
}


/* cs_destroy
 *
 * destroy a configuration set pointed to by `cs_set'
 */

void
cs_destroy (configset *cs_set)
{
	/* sanity checking
	 */
	if (cs_set == NULL)
		return;

	if (cs_set->nameserver != NULL)
		free (cs_set->nameserver);
	if (cs_set->local_dns != NULL)
		free (cs_set->local_dns);
	if (cs_set->local_domain != NULL)
		free (cs_set->local_domain);
	if (cs_set->spoof_name != NULL)
		free (cs_set->spoof_name);
	if (cs_set->spoof_ip != NULL)
		free (cs_set->spoof_ip);

	free (cs_set);

	return;
}


#endif

