
/* zodiac - advanced dns spoofer
 *
 * graphical user interface configuration routine include file
 *
 * by scut / teso
 */

#ifndef	Z_GUI_CONFIG_H
#define	Z_GUI_CONFIG_H

/* struct configset
 *
 * handles the data passing to the spoof routines. this structure represents
 * the actual content of the configuration forms in the gui. on action, this
 * data is duplicated and then passed to a spoof function :)
 */

typedef struct	configset {
	char	*nameserver;	/* victim nameserver */
	char	*spoof_victim;	/* for local spoofs only, what client machines should be
				 * affected on local spoof, can be NULL in any spoof,
				 * at local spoof NULL means any reachable client is affected
				 */

	char	*local_domain;	/* domain that the local server is aa for */
	char	*local_dns;	/* local domain name server */
	char	*local_dns_ip;	/* ip of the local nameserver (spoofed or real)
				 */

	int	spoof_type;	/* spoof types (see dns.h, TY_*) */

	char	*spoof_from;	/* name / ip to spoof */
	char	*spoof_to;	/* response that should be spoofed */
} configset;


/* cs_dupe
 *
 * duplicate the configuration set pointed to by `original'
 * return a new one
 */
configset	*cs_dupe (configset *original);


configset	*cs_new (void);


/* cs_init
 *
 * initialize a configuration set pointed to by `cs_set'
 */
void		cs_init (configset *cs_set);


/* cs_destroy
 *
 * destroy a configuration set pointed to by `cs_set'
 */
void		cs_destroy (configset *cs_set);


#endif

