/* zodiac - advanced dns spoofer
 *
 * by team teso
 */

#include <stdlib.h>
#include <string.h>
#include <ncurses.h>
#include "common.h"
#include "dns.h"
#include "dns-spoof.h"
#include "gui.h"
#include "gui-config.h"
#include "output.h"
#include "zodiac.h"


char	*input = NULL;
char	*prompt = NULL;


void
menu_prompt (char *pr)
{
	if (prompt == NULL) {
		prompt = xstrdup (pr);
	} else {
		free (prompt);
		prompt = xstrdup (pr);
	}
	m_printf (ms, ms->winsh, "%s", prompt);

	return;
}


void
menu_clear (void)
{
	if (input != NULL)
		free (input);
	input = NULL;
}


void
menu_tool (void)
{
}

void
menu_dos (void)
{
}


void
menu_spoof_jizz (void)
{
	configset	*cs = xcalloc (1, sizeof (configset));

	cs->nameserver = menu_input ();
	cs->local_domain = menu_input ();
	cs->local_dns_ip = menu_input ();
	cs->spoof_from = menu_input ();
	cs->spoof_to = menu_input ();
 
	xthread (cs, spoof_jizz);

	return;
}

void
menu_spoof_local (void)
{
	configset	*cs = xcalloc (1, sizeof (configset));
	char		*sp_type;

	cs->spoof_victim = menu_input ();
	sp_type = menu_input ();
	if (strcasecmp (sp_type, "a") == 0) {
		cs->spoof_type = T_A;
	} else if (strcasecmp (sp_type, "ptr") == 0) {
		cs->spoof_type = T_PTR;
	} else {
		m_printf (ms, ms->winsh, "#! invalid spoof type\n");
		menu_clear ();
		return;
	}
	free (sp_type);

	cs->spoof_from = menu_input ();
	cs->spoof_to = menu_input ();
	cs->local_dns = menu_input ();
	cs->local_dns_ip = menu_input ();

	xthread (cs, spoof_local);

	return;
}


void
menu_spoof_dnsid (void)
{
	configset	*cs = xcalloc (1, sizeof (configset));

	cs->nameserver = menu_input ();
	cs->local_domain = menu_input ();

	xthread (cs, spoof_dnsid);

	return;
}


void
menu_spoof (void)
{
	char	*basecmd;

	menu_prompt ("[spoof] > ");
	basecmd = menu_input ();
	if (strcasecmp (basecmd, "local") == 0) {
		menu_spoof_local ();
	} else if (strcasecmp (basecmd, "jizz") == 0) {
		menu_spoof_jizz ();
	} else if (strcasecmp (basecmd, "id") == 0) {
		menu_spoof_dnsid ();
	} else {
		m_printf (ms, ms->winsh, "#! not a valid spoof subcommand\n");
		menu_clear ();
	}
	return;
}


void
menu_handle (void)
{
	char	*basecmd;

m_root:
	menu_prompt ("[] > ");

	do {
		basecmd = menu_input ();

		if (strlen (basecmd) == 0)
			goto m_root;

		/* lame code here
		 */
		if (strcasecmp (basecmd, "quit") == 0) {
			return;
		} else if (strcasecmp (basecmd, "spoof") == 0) {
			menu_spoof ();
		} else if (strcasecmp (basecmd, "tool") == 0) {
//			menu_tool ();
		} else if (strcasecmp (basecmd, "dos") == 0) {
//			menu_dos ();
		} else {
			m_printf (ms, ms->winsh, "#! wrong command\n");
			goto m_root;
		}

		free (basecmd);
		basecmd = NULL;

	} while (1);
}


char *
menu_input (void)
{
	char	*p;
	int	cl;

	if (input == NULL) {
		input = xcalloc (1, 1024);
		wscanw (ms->winsh, "%1023c", input);
	}

	cl = strcspn (input, " \t\n\r");

	p = xcalloc (1, cl + 1);
	memcpy (p, input, cl);

	if (strlen (input + cl + 1) > 0) {
		int	n = strlen (input + cl + 1);

		memmove (input, input + cl + 1, strlen (input + cl + 1));
		memset (input + n, '\0', cl);
	} else {
		free (input);
		input = NULL;
	}

	return (p);
}


