/* zodiac - advanced dns id spoofer
 *
 * by team teso
 *
 *
 */

#define	ZODIAC_MAIN

#include <unistd.h>
#include <pthread.h>
#include <semaphore.h>
#include <stdio.h>
#include <stdlib.h>
#include <ncurses.h>
#include "common.h"
#include "dns.h"
#include "dns-spoof.h"
#include "dns-tools.h"
#include "gui.h"
#include "gui-config.h"
#include "output.h"
#include "packet.h"
#include "sniff.h"

mscr		*ms;		/* global screen variable */

int
main (int argc, char **argv)
{
	pq_thread	*pmain;
	pthread_t	sniff_t; 
	char		*interface = "eth0";

	if (argc >= 3) {
		printf ("usage: %s [interface]\n\n", argv[0]);
		exit (EXIT_FAILURE);
	} else if (argc == 2) {
		interface = argv[1];
	}

	ms = out_init ();
	if (ms == NULL) {
		fprintf (stderr, "[zod] cannot initialize console\n");
		exit (EXIT_FAILURE);
	}

	/* install a sniffing handler
	 */
	pmain = pq_create ();
	if (pmain == NULL) {
		m_printf (ms, ms->winproc, "[zod] failed to create packetizer thread\n");
		endwin ();
		exit (EXIT_FAILURE);
	}

	if (sniff_new (&sniff_t, interface, pmain)) {
		m_printf (ms, ms->winproc, "[zod] failed to create new sniffing thread\n");
		endwin ();
		exit (EXIT_FAILURE);
	}

	m_printf (ms, ms->winproc, "[zod] zodiac successfully started\n");

	/* JUST TESTING PURPOSES
	 */
//	dt_bind_version ("123.123.123.123");

//	spoof_local (&blaspoof);

	menu_handle ();

	endwin ();

	exit (EXIT_SUCCESS);
}


